var mode = 1;
var nbplayers = 1;
var lightprima = "#DEDEDE";
var lightsedonca = "#B7B7B7";
var lighttercia = "#E6E6E6";

var darkprima = "#474747";
var darkseconda = "#393939";
var darktercia = "#606060";
var carteselect = [];
var deckPartie = []; //Ensemble des cartes affichées à l'écran

class Carte {

	constructor(id/*,row,column,nbForme*/) { //à décommenter quand il y aura des prametres de partie
		//Attribut de Classe
		this.identifiant = id;
		this.row = 4 /*row*/;
		this.column = 3 /*column*/;
		this.Matrice = creaMatrice(this.row, this.column);

		//lien clicable
		this.link = document.createElement('a');
		this.link.id = this.identifiant;
		//fonction de selection
		/*this.link.onclick = function selectioncarte() {
			window.alert(this.getFigureCreuse)
			window.alert(this.getFigureCreuse)
			var macarte = this.id;
			var lacarte = "card" + macarte;
			if (document.getElementById(lacarte).style.boxShadow != "") {
				var pos = carteselect.indexOf(this.getIdentifiant);
				carteselect.splice(pos, 1);
				document.getElementById(lacarte).style.boxShadow = "";
			}
			else {
				if (carteselect.length < 5) {
					carteselect.push(this.getIdentifiant);
					document.getElementById(lacarte).style.boxShadow = "0 0 1vw red, 0 0 1vw red";
				}
				else
					window.alert("Bonjour !");
			}
		};*/

		//div carte
		var divconteneur = document.createElement('div');
		divconteneur.className = "flex-item";
		divconteneur.id = "card" + this.identifiant;

		for (var i = 0; i < 12; i++) {

			var divcase = document.createElement('div');
			divcase.className = "item-form";

			// Point ou anneau trouvé => création
			if (this.Matrice[i % 3][Math.floor(i / 3)] == 1) {

				//TEST : CRéation d'une figure Pleine => Rond
				var uneFigure = new Figure(TypeFigure.Pleine, FormeFigure.Rond, i % 3, Math.floor(i / 3));
				this.FigPleine = uneFigure;

				divconteneur.appendChild(uneFigure.getHTML);


			} else if (this.Matrice[i % 3][Math.floor(i / 3)] == 2) { // Point ou anneau trouvé => création

				//TEST : CRéation d'une figure Pleine => Anneau

				var uneFigure = new Figure(TypeFigure.Creuse, FormeFigure.Rond, i % 3, Math.floor(i / 3));


				this.FigCreuse = uneFigure;

				divconteneur.appendChild(uneFigure.getHTML);

			} else divconteneur.appendChild(divcase);

		}

		this.link.appendChild(divconteneur);
		//fonction de selection
		this.link.onclick = function selectioncarte() {
			var macarte = this.id;
			var lacarte = "card" + macarte;

			var laCarte = deckPartie[this.id - 1]; //Carte liée avec le code HTML

			if (document.getElementById(lacarte).style.boxShadow != "") {
				var pos = carteselect.indexOf(laCarte);
				carteselect.splice(pos, 1);
				document.getElementById(lacarte).style.boxShadow = "";
			}
			else {
				if (carteselect.length < 5) {
					carteselect.push(laCarte);
					document.getElementById(lacarte).style.boxShadow = "0 0 1vw red, 0 0 1vw red";
				}
				else
					window.alert("Bonjour !");
			}
		};
	}

	get getHTML() {
		return this.link;
	}

	get getIdentifiant() {
		return this.identifiant;
	}

	get getMatrice() {
		return this.Matrice;
	}

	get getFigurePleine() {
		return this.FigPleine;
	}

	get getFigureCreuse() {
		return this.FigCreuse;
	}

}

class Figure {

	constructor(type, forme, Cox, Coy) {
		this.X = Cox;
		this.Y = Coy;
		this.type = type;
		this.forme = forme;
		var pos = this.X + this.Y * 3;
		var divcase = document.createElement('div');
		divcase.className = "item-form";
		switch (this.forme) {
			case FormeFigure.Rond:
				switch (this.type) {

					case TypeFigure.Creuse:

						var divContainForm = document.createElement('div');
						divContainForm.className = "containform";

						var unCercle = document.createElement('div');
						unCercle.className = "anneau";

						if (pos == 0 || pos == 2 || pos == 9 || pos == 11) {
							unCercle.style.backgroundColor = "#00CBFF";
						}
						if (pos == 1 || pos == 10) {
							unCercle.style.backgroundColor = "#00FF6E";
						}
						if (pos == 4 || pos == 7) {
							unCercle.style.backgroundColor = "#C800FF";
						}

						var unRond = document.createElement('div');
						unRond.className = "rondinterieur inté";

						unCercle.appendChild(unRond);
						divContainForm.appendChild(unCercle);
						divcase.appendChild(divContainForm);
						this.CodeHTML = divcase;
						break;

					case TypeFigure.Pleine:

						var divContainForm = document.createElement('div');
						divContainForm.className = "containform";

						var unRond = document.createElement('div');
						unRond.className = "rond";
						//unRond.style.backgroundColor = "#000DFF";
						if (pos == 0 || pos == 2 || pos == 9 || pos == 11) {
							unRond.style.backgroundColor = "#00CBFF";
						}
						if (pos == 1 || pos == 10) {
							unRond.style.backgroundColor = "#00FF6E";
						}
						if (pos == 4 || pos == 7) {
							unRond.style.backgroundColor = "#C800FF";
						}
						divContainForm.appendChild(unRond);
						divcase.appendChild(divContainForm);
						this.CodeHTML = divcase;
						break;

				}
		}
	}

	get getHTML() {
		return this.CodeHTML;
	}

	get getX() {
		return this.X;
	}
	get getY() {
		return this.Y;
	}
	get getType() {
		return this.type;
	}
	get getForme() {
		return this.forme;
	}


}

const FormeFigure = {
	Rond: 'rond',
	Carre: 'carre',
	Triangle: 'triangle',
	Pentagone: 'pentagone',
	Losange: 'Losange'
};

const TypeFigure = {
	Pleine: 'pleine',
	Creuse: 'creuse'
};


function journuit() {
	//mode jour
	if (mode % 2 == 0) {
		//changer logo swish
		document.getElementById("imglogo").src = "imgs/swishjour.png";
		document.getElementById("imglogo2").src = "imgs/swishjour.png";
		/*
		MESSAGE POUR CEUX QUI FONT LES TESTS ! Recommentez les lignes après ! Merci
		*/
		//document.getElementById("fondinput").style.backgroundColor = lightsedonca;
		document.getElementById("contourbuttonvalider").style.backgroundColor = lightsedonca;
		//document.getElementById("textjouer").style.color = lightsedonca;
		//document.getElementById("textplus").style.color = lightprima;
		//changer montagnesfond
		document.getElementById("mount1").src = "imgs/mount1.png";
		document.getElementById("mount2").src = "imgs/mount2.png";
		//nuages
		document.getElementById("cloud").src = "imgs/lightcloud.png";
		//changer background color
		//document.getElementById("containplayers").style.color = lightsedonca;
		//maj couleur principales
		document.documentElement.style.setProperty('--lightprima', lightprima);
		document.documentElement.style.setProperty('--lightsedonca', lightsedonca);
		document.documentElement.style.setProperty('--lighttercia', lighttercia);
	}
	//mode nuit
	else {
		//changer logo swish
		document.getElementById("imglogo").src = "imgs/swishnuit.png";
		document.getElementById("imglogo2").src = "imgs/swishnuit.png";

		//document.getElementById("fondinput").style.backgroundColor = darkseconda;
		document.getElementById("contourbuttonvalider").style.backgroundColor = darkseconda;
		//document.getElementById("textjouer").style.color = darkseconda;
		//document.getElementById("textplus").style.color = darkprima;
		//changer montagnesfond
		document.getElementById("mount1").src = "imgs/darkmount1.png";
		document.getElementById("mount2").src = "imgs/darkmount2.png";
		//nuages
		document.getElementById("cloud").src = "imgs/darkcloud.png";
		//mode nuit
		//document.getElementById("containplayers").style.color = darkseconda;
		//maj couleur principales
		document.documentElement.style.setProperty('--lightprima', darkprima);
		document.documentElement.style.setProperty('--lightsedonca', darkseconda);
		document.documentElement.style.setProperty('--lighttercia', darktercia);
	}
	mode = mode + 1;
}

function lancerpartie() {
	document.getElementById("pageAccueil").style.visibility = "hidden";
	creePartie();
	document.getElementById("pageGame").style.visibility = "visible";
}

function retour() {
	document.getElementById("pageAccueil").style.visibility = "visible";
	document.getElementById("pageGame").style.visibility = "hidden";
}

function creePartie() {
	carteselect = [];
	while (document.getElementById("containcards").firstElementChild != null) {
		document.getElementById("containcards").firstElementChild.remove();
	}
	for (var j = 1; j <= 16; j++) {

		var uneCarte = new Carte(j);

		deckPartie.push(uneCarte);

		document.getElementById("containcards").appendChild(uneCarte.getHTML);
	}
}

function CarteToMatrice(idcarte) {
	var laDivEnfantCarte = document.getElementById(idcarte).firstElementChild;
	var cols = 3;
	var rows = 4;
	var myMatrice = new Array();
	for (var i = 0; i < cols; i++) {
		myMatrice[i] = new Array();
		for (var j = 0; j < rows; j++) {
			myMatrice[i][j] = 0;
		}
	}
	for (var i = 0; i < laDivEnfantCarte.childNodes.length; i++) {


		if (laDivEnfantCarte.childNodes[i].childNodes.length != 0) {
			if (laDivEnfantCarte.childNodes[i].childNodes[0].firstChild.className == "anneau") {
				myMatrice[i % 3][Math.floor(i / 3)] = 2;
			}
			if (laDivEnfantCarte.childNodes[i].childNodes[0].firstChild.className == "rond") {
				myMatrice[i % 3][Math.floor(i / 3)] = 1;
			}
		}

	}
	return myMatrice;
}

function getRandom(min, max) {
	return Math.round(Math.random() * (max - min) + min)
}

function creaMatrice(row, column) {
	var myMatrice = new Array();
	for (var i = 0; i < column; i++) {
		myMatrice[i] = new Array();
		for (var j = 0; j < row; j++) {
			myMatrice[i][j] = 0;
		}
	}

	var Cox1, Coy1, Cox2, Coy2;

	Cox1 = getRandom(0, 2);
	Coy1 = getRandom(0, 3);

	myMatrice[Cox1][Coy1] = 1;

	Cox2 = getRandom(0, 2);
	Coy2 = getRandom(0, 3);

	while (Cox2 == Cox1 && Coy1 == Coy2) {
		Cox2 = getRandom(0, 2);
		Coy2 = getRandom(0, 3);
	}
	myMatrice[Cox2][Coy2] = 2;

	return myMatrice;

}

//FONCTION DE TEST => permet de tester des fonctionnalité via un bouton
function test() {

	if (carteselect.length < 2) {
		window.alert("Selection trop petite");
		return;
	} else {
		var Code = comparaisonDeCarte(carteselect[0], carteselect[1]);
		window.alert(Code);
	}


}


function comparaisonDeCarte(CarteMere, CarteFille) {
	var Code = 0;
	if (CarteMere == null) {
		return 2;
	}
	var matCarteMere = CarteMere.getMatrice;
	//CAS 1 : Il existe déja un ensemble( point <=> cercle ) sur CarteMere là où CarteFille possède un point ou un cercle
	if ((matCarteMere[CarteFille.FigCreuse.X][CarteFille.FigCreuse.Y] == 3) || (matCarteMere[CarteFille.FigPleine.X][CarteFille.FigPleine.Y] == 3)) {
		//Impossible d'empiler
		return 0;
	}
	//CAS 2 :  L'emplassement est parfait ! Les Coordonnées sont bonnes
	if (matCarteMere[CarteFille.FigCreuse.X][CarteFille.FigCreuse.Y] == 1) {
		if (matCarteMere[CarteFille.FigPleine.X][CarteFille.FigPleine.Y] == 2) {
			//Coordonnées parfaites
			return 2;
		}

	}
	//CAS 3 : une seule liaison est possible
	if ((matCarteMere[CarteFille.FigCreuse.X][CarteFille.FigCreuse.Y] == 1) || (matCarteMere[CarteFille.FigPleine.X][CarteFille.FigPleine.Y] == 2)) {
		return 1;
	}
	//Dernier cas : on ne peut rien faire avec ces cartes
	return Code;

}




function ChoisirPseudo() {
	let nom = localStorage.getItem('nom');
	if (nom == null) {
		nom = "SWISH";
	}
	document.getElementById('inputpseudo').setAttribute('value', nom);
};

function EnvoyerNouveauNom() {
	let pseudo = document.getElementById('inputpseudo').value;
	localStorage.setItem('nom', pseudo);
	document.location.reload(true);

};

/*
function addplayer(){
	//j'ai mis une limite de 6joueurs, mais c'est à voir
	if(nbplayers < 7){
		//création de la div contenant le pseudo
		var divpseudo = document.createElement('div');
		divpseudo.id = 'pseudolist';
		//reprise du pseudo entré par le joueur
		var pseudo = document.getElementById("inputpseudo").value;
		//vérification si pseudo vide pour lui donner un pseudo du style "Joueur3"
		if(pseudo == "")
		{
			pseudo = "Joueur " + nbplayers;
		}
		//création du text-pseudo
		var tag = document.createElement("p");
		tag.className = "pseudojoueur";
	    var text = document.createTextNode(pseudo);
	    tag.appendChild(text);
	    //mise du text dans la division
	    divpseudo.appendChild(tag);
	    //insertion pseudo dans liste
		document.getElementById("containplayers").appendChild(divpseudo);
		//remise input vide ;)
		document.getElementById("inputpseudo").value = "";
		nbplayers = nbplayers +1;
	}
}

function ajouterplayer(event){
	if(event.keyCode == 13)
		addplayer();
}

*/





